<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Journal Plug-in for Geeklog 1.3.x                                         |
// +---------------------------------------------------------------------------+
// | function.inc                                                              |
// | Core function for journal plug-in                                         |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2001 by the following authors:                              |
// |                                                                           |
// | Authors: Tony Bibbs - tony@tonybibbs.com                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | See the docs/install.html and docs/config.html files for more information |
// | on configuration                                                          |
// +---------------------------------------------------------------------------+
//
// $Id: functions.inc,v 1.1.1.1 2003/06/10 20:33:24 dirk Exp $

$langfile = $_CONF['path'] . 'plugins/journal/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile)) {
    include_once ($langfile);
} else {
    include_once ($_CONF['path'] . 'plugins/journal/language/english.php');
}

include($_CONF['path'] . 'plugins/journal/journal.cfg');

function plugin_printheadermenuitem_journal() {
        global $LANG_JOURNAL;
        $retval .= "&#149; <a class=navtext href={$_CONF["site_url"]}/journal/index.php>{$LANG_JOURNAL["journalslcase"]}</a> ";
}

function plugin_commentsupport_journal() {
	return true;
}

function plugin_commentsave_journal($id) {
    global $_CONF,$_TABLES;
    // Get the total number of comments now related to this commment id - which is also the plugin record id.
	$comments = DB_count($_TABLES['comments'],'sid',$id);
	// Update the the Journal Entry record for this file with the number of related comments
	DB_change($_TABLES['journal_entry'],'je_comment', $comments, 'je_id',$id);
	// Now redirect the program flow to the view of the file and its comments
    echo COM_refresh($_CONF['site_url'] . "/journal/index.php?mode=read&type=entry&je_id=$id");
}

function plugin_commentform_journal($id,$commentmode='',$order='',$reply='') {
    global $_CONF,$_TABLES;
	$commentCount = DB_count($_TABLES['comments'],'sid',$id);
	$title = DB_getItem($_TABLES['journal_entry'],'je_summary',"je_id=$id");
	if ($commentmode == "") {
	    $commentmode = $_CONF['comment_mode'];
	}
	if ($order == "") {
	    $order="ASC"; 
	}	
	$type="journal";
	if ($commentCount == 0 || $reply != "") {
		$pid=0;
	    echo COM_refresh($_CONF['site_url'] . "/comment.php?sid=$id&amp;pid=$pid&amp;type=$type");
	} else {
		$display = COM_siteHeader() . printjournalentry($id) . COM_userComments($id,$title,$type,$order,$commentmode);
		$display .= COM_siteFooter();
    } 
    return $display;
}



function plugin_showstats_journal($showsitestats) {
}

function plugin_dopluginsearch_journal($query, $datestart, $dateend, $topic, $type, $author) {
	global $_TABLES,$_CONF;
	
	
	if (empty($type)) {
        $type = 'all';
    }
    
	// Bail if we aren't supppose to do our search
    if ($type <> 'all' AND $type <> 'journal') {
        $plugin_results = new Plugin();
        $plugin_results->plugin_name = 'Journal';
        $plugin_results->searchlabel = 'Journal Search Results';
        return $plugin_results;
    }
	
	$sql = "SELECT je_id,je_summary,je_text,UNIX_TIMESTAMP(je_date) as day,'journal' as type,jrn_name,jt_name,jrn_uid,je_hits FROM {$_TABLES['journal_entry']},{$_TABLES['journal_type']},{$_TABLES['journal']}"; 
	$sql .= " WHERE ((jrn_id = je_jrn_id) AND (jt_id = jrn_jt_id) AND (je_public = 1) AND (jrn_public = 1)) AND ";
    $sql .= "((jrn_name like '%$query%') ";
    $sql .= "OR (je_text like '%$query%') ";
    $sql .= "OR (je_summary like '%$query%')) ";
    if (!empty($datestart) && !empty($dateend)) {
        $delim = substr($datestart, 4, 1);
        $DS = explode($delim,$datestart);
        $DE = explode($delim,$dateend);
        $startdate = mktime(0,0,0,$DS[1],$DS[2],$DS[0]);
        $enddate = mktime(0,0,0,$DE[1],$DE[2],$DE[0]) + 3600;
        $sql .= "AND (UNIX_TIMESTAMP(date) BETWEEN '$startdate' AND '$enddate') ";
    }
    $sql    .= "ORDER BY day DESC";
	
	// Perform search
    $result = DB_query($sql);
	
    require_once($_CONF['path_system'] . 'classes/plugin.class.php');
	$plugin_results = new Plugin();
    $plugin_results->plugin_name = 'journal';
    $plugin_results->searchlabel = 'Journal Search Results';
    $plugin_results->addSearchHeading('Journal');
    $plugin_results->addSearchHeading('Summary');
    $plugin_results->addSearchHeading('DATE');
    $plugin_results->addSearchHeading('Author');
    $plugin_results->addSearchHeading('Views');
    $plugin_results->num_searchresults = DB_numRows($result);
	
	for ($i = 1; $i <= $plugin_results->num_searchresults; $i++) {
        $A = DB_fetchArray($result);
		$username = DB_getItem($_TABLES['users'],"username","uid = {$A['jrn_uid']}");
		$date = strftime('%b %d %Y @ %I:%M %p', $A['day']);
		$url = '<a href="' . $_CONF['site_url'] . '/journal/index.php?mode=read&amp;type=entry&amp;je_id=' . $A['je_id'] . '">' . stripslashes ($A['je_summary']) . '</a>';
		$row = array($A['jrn_name'],$url,$date,$username,$A['je_hits']);
        $plugin_results->addSearchResult($row);
	}
	
    $plugin_results->num_itemssearched = DB_count($_TABLES['journal_entry']);

    return $plugin_results;
	
}

function plugin_searchtypes_journal() {
	global $LANG_JOURNAL;
	$tmp['journal'] = $LANG_JOURNAL[journal];
    return $tmp;
	
}

function plugin_cclabel_journal() {
	return array($_CONF["site_url"] . "/journal/images/journal.gif", "Journal");
}

function plugin_adminedit_journal() {
	global $_CONF, $LANG_JOURNAL;
	
	$retval = "<table border=0 cellspacing=0 cellpadding=2 width=\"100%\">";
    $retval .= "<tr><td rowspan=2><img src={$_CONF["site_url"]}/journal/images/journal.gif></td>";
    $retval .= "<td>[ <a href={$_CONF["site_url"]}/journal/index.php>{$LANG_JOURNAL[newjournaltype]} $type</a> | <a href={$_CONF["site_url"]}/admin>{$LANG_JOURNAL[adminhome]}</a> ]</td></tr>";
    $retval .= "<tr><td>$text</td></tr>";
    $retval .= "</table><p>";
	
	return true;
}

function plugin_getuseroption_journal() {
	global $_CONF, $_USER, $LANG_JOURNAL, $_TABLES;
    return array($LANG_JOURNAL['myjournals'], $_CONF['site_url'] . '/journal/index.php?mode=user', DB_count($_TABLES['journal'],"jrn_uid",$_USER['uid']));
}

function plugin_getadminoption_journal() {
    global $_CONF, $_USER, $LANG_JOURNAL, $_TABLES;
        
    if (SEC_inGroup('Journal Admin')) {
        return array($LANG_JOURNAL['journals'], $_CONF['site_url'] . '/journal/index.php', DB_count($_TABLES['journal']));
    }
}

function plugin_itemlist_journal() {
	return;
}

function showpublicjournals() {
}

function changejournal($jrn_id) {
	global $_USER,$_CONF, $_TABLES;

	DB_query("UPDATE {$_TABLES['journal']} SET jrn_iscurrent = 0 WHERE jrn_uid = {$_USER["uid"]}");
	DB_query("UPDATE {$_TABLES['journal']} SET jrn_iscurrent = 1 WHERE jrn_id = $jrn_id");

	echo COM_refresh($_CONF['site_url'].'/journal/index.php?mode=user');	
}

function userjournaldropdown($uid, $jrn_id, $title) {
	global $LANG_JOURNAL, $_TABLES, $_CONF;

	$result = DB_query("SELECT jrn_id,jrn_name FROM {$_TABLES['journal']} WHERE jrn_uid = $uid ORDER BY jrn_name");
	$nrows = DB_numRows($result);
	if ($nrows == 0) {
		return "No journals found for you! Click 'New Journal' to create one";
	}
	$text = '<form action="' . $PHP_SELF . '" method="post">';
	$text .= $title;
	$text .= "<input type=hidden name=mode value=changejournal>";
	$text .= "<select name=jrn_id onChange=\"this.form.submit()\">";
	
	for ($i = 1; $i <= $nrows; $i++) {
		$A = DB_fetchArray($result);
		$text .= "\n<option value={$A["jrn_id"]}";
		if ($A["jrn_id"] == $jrn_id) {
			$text .= " SELECTED";
		}
		$text .= ">".stripslashes($A["jrn_name"])."</option>";
	}
	$text .= "</select>[ <a href={$_CONF["site_url"]}/journal/index.php?mode=edit&type=journal&jrn_id=$jrn_id>{$LANG_JOURNAL[edit]}</a> ]</form>";
	
	return $text;
}

function shownavigation($mode,$jrn_id="") {
	global $_CONF,$_USER,$LANG_JOURNAL;

	$uid = 0;
	if (empty($_USER["uid"])) {
		$uid = 1;	
		$retval = COM_startBlock($LANG_JOURNAL[anonymous] . ' Journal Menu');
	} else {
		$retval = COM_startBlock($_USER['username'] . '\'s Journal Menu');
	}

	$retval .= "<table border=0 cellspacing=0 cellpadding=2 width=\"100%\">";
	$retval .= "<tr><td rowspan=2><img src={$_CONF["site_url"]}/journal/images/journal.gif></td>";

	if ($uid == 1) {
		#this user is browsing anonymously show them a really generic, useless
		#menu that encourages them to sign up!
		$retval .= '<td>'.$LANG_JOURNAL[encouragement].'</td></tr></table>';
	} else {
		$retval .= "<td>[ ";
		if ($mode <> "user") {
			$retval .= "<a href={$_CONF["site_url"]}/journal/index.php?mode=user>My Journals</a> | ";
		}

		#The following line will be used after I get time to implement user preferences so don't
		#delete it

		#$retval .= "<a href={$_CONF["site_url"]}/journal/index.php?mode=newjournal>New Journal</a> | <a href={$_CONF["site_url"]}/journal/index.php?mode=newentry&jrn_id=$jrn_id>New Entry</a> | <a href={$_CONF["site_url"]}/journal/prefs.php>{$LANG_JOURNAL["preferences"]}</a> ]</td></tr>";
		$retval .= "<a href={$_CONF["site_url"]}/journal/index.php?mode=newjournal>{$LANG_JOURNAL[newjournal]}</a> | <a href={$_CONF["site_url"]}/journal/index.php?mode=newentry&jrn_id=$jrn_id>{$LANG_JOURNAL[newentry]}</a> | <a href={$_CONF["site_url"]}/journal/index.php>{$LANG_JOURNAL[publicjournals]}</a> ]</td></tr>";
		$retval .= "<tr><td colspan=2>";
		$retval .= userjournaldropdown($_USER["uid"],$jrn_id,$LANG_JOURNAL[currentjournal].": ");
		$retval .= "</td></tr></table>";
	}
	$retval .= COM_endBlock();
	
	return $retval;
}

function journalentryeditor($jrn_id,$userwaswarned,$A="") {
	global $PHP_SELF,$_CONF,$HTTP_POST_VARS,$_USER,$LANG_JOURNAL,$_TABLES;

	if (empty($jrn_id)) {
		$error = "No journal was passed to function journalentryeditor";
	} else {
		$result = DB_query("SELECT * FROM {$_TABLES['journal']} WHERE jrn_id = $jrn_id");
		$JOURNAL = DB_fetchArray($result);
		if (($_USER["uid"] <> $JOURNAL["jrn_uid"]) AND (!SEC_inGroup('Journal Admin'))) {
			#someone is trying to illegally access this editor, log it
			$retval .= COM_startBlock($LANG_JOURNAL[accessviolation]);
			$retval .= $LANG_JOURNAL[accessviolationmsg];
			$retval .= COM_endBlock();
			COM_errorLog("User {$_USER["username"]} tried illegally accessing the journal editor for journal $jrn_id",1);
			return $retval;
		}
	}

    if ($error) {
        $retval .= $error . "<BR><BR>";
    } else {
        $retval .= COM_startBlock($LANG_JOURNAL[journalentryeditor]);
        $retval .= "\n<form action=\"" . $PHP_SELF . "\" method=\"post\">";
        $retval .= "\n<table border=0 cellspacing=0 cellpadding=3 width=\"100%\">";
        $retval .= "\n<tr><td align=center colspan=2>";
        $retval .= "<input type=submit value={$LANG_JOURNAL[save]} name=mode>";
        $retval .= "<input type=hidden value=entry name=type> ";
        if (!empty($A["je_id"])) {
            $retval .= "\n<input type=submit value={$LANG_JOURNAL[delete]} name=mode> ";
            $retval .= "\n<input type=hidden name=je_id value={$A["je_id"]}>";
        }
		$retval .= "<input type=submit value={$LANG_JOURNAL[cancel]} name=mode>";
		#note: the line below is very important in the deletion process.  Do not touch
		$retval .= "<input type=hidden value=$userwaswarned name=verified>";
        $retval .= "\n<tr></td>";
        $retval .= "\n<tr><td align=right><b>{$LANG_JOURNAL[submittedby]}</b>:</td><td>";
		if (empty($A["jrn_uid"])) {
			$retval .= $_USER["username"];
		} else {
			$retval .= DB_getItem($_TABLES['users'],"username","uid = {$A["jrn_uid"]}");
		}
        $retval .= "\n</td><tr><td align=right><b>{$LANG_JOURNAL[journal]}</b>:</td><td>".stripslashes($JOURNAL["jrn_name"])."<input type=hidden name=je_jrn_id value=$jrn_id></td></tr>";
        $retval .= "\n<tr><td align=right><b>{$LANG_JOURNAL[dateentered]}</b>:</td><td>";
        if (empty($A["unixdate"])) {
			$curtime = COM_getUserDateTimeFormat();
        } else {	
			$curtime = COM_getUserDateTimeFormat($A["unixdate"]);
		}
        $retval .= $curtime[0] . "<input type=hidden name=unixdate value={$curtime[1]}></td></tr>";
        $retval .= "\n<tr><td align=right><b>{$LANG_JOURNAL[summary]}</b>:</td><td><input type=text size=48 maxlength=255 name=je_summary value=\"" . stripslashes($A["je_summary"]) . "\"></td></tr>";
		$retval .= "\n<tr><td align=right><b>{$LANG_JOURNAL[mood]}</b>:</td><td>";
		$retval .= "<img alt=confused src={$_CONF["site_url"]}/journal/images/confused_phpbb.gif>&nbsp;<input type=radio name=je_mood value=confused ";
		if ($A["je_mood"] == 'confused') $retval .= "CHECKED";
		$retval .= ">&nbsp;&nbsp;&nbsp;&nbsp;<img alt=embarassed src={$_CONF["site_url"]}/journal/images/embarassed_phpbb.gif>&nbsp;<input type=radio name=je_mood value=embarassed ";
		if ($A["je_mood"] == 'embarassed') $retval .= "CHECKED";
		$retval .= ">&nbsp;&nbsp;&nbsp;&nbsp;<img alt=happy src={$_CONF["site_url"]}/journal/images/happy_phpbb.gif>&nbsp;<input type=radio name=je_mood value=happy ";
		if ($A["je_mood"] == 'happy') $retval .= "CHECKED";
		$retval .= ">&nbsp;&nbsp;&nbsp;&nbsp;<img alt=mad src={$_CONF["site_url"]}/journal/images/mad_phpbb.gif>&nbsp;<input type=radio name=je_mood value=mad ";
		if ($A["je_mood"] == 'mad') $retval .= "CHECKED";
		$retval .= ">&nbsp;&nbsp;&nbsp;&nbsp;<img alt=sad src={$_CONF["site_url"]}/journal/images/sad_phpbb.gif>&nbsp;<input type=radio name=je_mood value=sad ";
		if ($A["je_mood"] == 'sad') $retval .= "CHECKED";
		$retval .= ">&nbsp;&nbsp;&nbsp;&nbsp;<img alt=surprised src={$_CONF["site_url"]}/journal/images/surprised_phpbb.gif>&nbsp;<input type=radio name=je_mood value=surprised ";
		if ($A["je_mood"] == 'surprised') $retval .= "CHECKED";
		$retval .= "></td><tr>";
		$retval .= "\n<tr><td valign=top align=right><b>{$LANG_JOURNAL[text]}<b>:</td><td><textarea name=je_text cols=75 rows=20 wrap=virtual>" . stripslashes($A["je_text"]) . "</textarea></td></tr>";
		if ($JOURNAL["jrn_public"] == 1) {
            $retval .= "\n<tr><td align=right><b>{$LANG_JOURNAL[public]}</b>:</td><td><input type=checkbox name=je_public ";                
			if (($A["je_public"] == 1) || ($JOURNAL["jrn_public"] == 1)) {	
                $retval .= "checked";
            }
			$retval .= ">&nbsp;&nbsp;(If checked, others will be able to read this journal entry)</td></tr>";
		}
        $retval .= "<tr><td align=right><b>{$LANG_JOURNAL[hits]}</b>:</td><td><input type=hidden name=je_hits value={$A["je_hits"]}>{$A["je_hits"]}</td></tr>";
        $retval .= "\n<tr><td align=center colspan=2>";
        $retval .= "<input type=submit value={$LANG_JOURNAL[save]} name=mode>";
        $retval .= "<input type=hidden value=entry name=type> ";
        if (!empty($A["je_id"])) {
            $retval .= "\n<input type=submit value={$LANG_JOURNAL[delete]} name=mode> ";
        }
		$retval .= "<input type=submit value={$LANG_JOURNAL[cancel]} name=mode>";
        $retval .= "\n<tr></td>";
        $retval .= "</table>";
        $retval .= COM_endBlock();
        $retval .= "</form>";
	}
	return $retval;
}

function journaleditor($userwaswarned,$A="") {
	global $PHP_SELF,$_CONF,$_TABLES,$HTTP_POST_VARS,$_USER,$LANG_JOURNAL;

    if ($error) {
        $retval .= $error . "<BR><BR>";
    } else {
        $retval .= COM_startBlock($LANG_JOURNAL[journaleditor]);
        $retval .= "\n<form action=\"" . $PHP_SELF . "\" method=\"post\">";
        $retval .= "\n<table border=0 cellspacing=0 cellpadding=3 width=\"100%\">";
        $retval .= "\n<tr><td colspan=2>";
		$retval .= "<input type=hidden value=journal name=type>";
		$retval .= "<input type=submit value={$LANG_JOURNAL[save]} name=mode>";
		if (!empty($A["jrn_id"])) {
            $retval .= "\n<input type=submit value={$LANG_JOURNAL[delete]} name=mode> ";
		}
		$retval .= "<input type=submit value={$LANG_JOURNAL[cancel]} name=mode>";
		#note: the line below is very important to the deletion process.  Do not touch!
		$retval .= "<input type=hidden value=$userwaswarned name=verified>";
        $retval .= "\n<tr></td>";
        $retval .= "\n<tr><td align=right>{$LANG_JOURNAL[submittedby]}:</td><td>";
		if (!empty($A["jrn_uid"])) {
			$retval .=  DB_getItem($_TABLES["users"],"username","uid = {$A["jrn_uid"]}");
			$retval .= "<input type=hidden name=jrn_uid value={$A["jrn_uid"]}></td></tr>";
		} else {
			$retval .= $_USER['username'];
			$retval .= "<input type=hidden name=jrn_uid value={$_USER["uid"]}></td></tr>";
		}
        $retval .= "\n<tr><td align=right>{$LANG_JOURNAL[datecreated]}:</td><td>";
		if (empty($A["unixdate"])) {
			$curtime = COM_getUserDateTimeFormat();
		} else {
			$curtime = COM_getUserDateTimeFormat($A["unixdate"]);
		}
		$retval .= $curtime[0] . "<input type=hidden name=unixdate value={$curtime[1]}></td></tr>";
        $retval .= "\n<tr><td align=right>{$LANG_JOURNAL[journalname]}:</td><td><input type=text size=48 maxlength=255 name=jrn_name value=\"" . stripslashes($A["jrn_name"]) . "\"></td></tr>";
        $retval .= "\n<tr><td align=right>{$LANG_JOURNAL[public]}:</td><td><input type=checkbox name=jrn_public ";               
		if ($A["jrn_public"] == 1) {
            $retval .= "checked";
        }
		$retval .= ">&nbsp;&nbsp;(If checked, others will be able to read this journal)</td></tr>";
		#if the following is true false then we have a prexisting record and there is no need
		# allow them to edit this because we must always have at least one current journal
		if (empty($A["jrn_id"])) {
			$result = DB_query("SELECT count(*) as count FROM {$_TABLES['journal']} WHERE jrn_uid = {$_USER["uid"]}");
			$B = DB_fetchArray($result);
			if ($B["count"] == 0) {
				#this is the users first journal so it must be current
				$retval .= "<input type=hidden name=jrn_iscurrent value=on>";
			} else {
                $retval .= "\n<tr><td align=right>{$LANG_JOURNAL[makecurrent]}:</td><td><input type=checkbox name=jrn_iscurrent ";                
				if (($A["jrn_iscurrent"] == 1) || (strlen($A["jrn_iscurrent"])==0)) {
                    $retval .= "checked";
                }
				$retval .= ">&nbsp;&nbsp;(If checked, this will be your default journal)</td></tr>";
			}
		}
        $result = DB_query("SELECT jt_id, jt_name FROM {$_TABLES['journal_type']} ORDER BY jt_name");
        $nrows = DB_numRows($result);
		if ($nrows == 1) {
			#If there is only one journal type then don't confuse the user by giving them
			#an option
			$B = DB_fetchArray($result);
			$retval .= "<input type=hidden name=jrn_jt_id value={$B["jt_id"]}>";
		} else {
            $retval .= "\n<tr><td align=right>{$LANG_JOURNAL[journaltype]}:</td><td>";
            if ($nrows > 0) {
                $retval .= "<select name=jrn_jt_id>\n";
				$retval .= "<option value=\"\">Select Journal Type</option>\n";
                for ($i=0;$i<$nrows;$i++) {
                    $B = DB_fetchArray($result);
					$retval .= "<option value={$B["jt_id"]}";
                    if ($A["jrn_jt_id"] == $B["jt_id"]) { 
                        $retval .= " selected"; 
                    }
                    $retval .= ">{$B["jt_name"]}</option>\n";
                }
                $retval .= "</select>\n";
            }
            $retval .= "\n</select></td></tr>";
		}
        $retval .= "</td></tr>\n";
        $retval .= "<tr><td align=right>{$LANG_JOURNAL[hits]}:</td><td><input type=hidden name=jrn_hits value={$A["jrn_hits"]}>{$A["jrn_hits"]}</td></tr>";
        $retval .= "<input type=hidden name=jrn_id value={$A["jrn_id"]}></td></tr>";
        $retval .= "</table>";
        $retval .= COM_endBlock();
        $retval .= "</form>";
    } # end if
    return $retval;
}

function savejournalentry($je_id, $je_jrn_id, $je_summary, $je_text, $je_public, $je_date, $je_hits, $je_mood) {
	global $_CONF,$LANG12,$LANG50, $_TABLES;

    if (!empty($je_summary) && !empty($je_text)) {
        if (strlen($je_id) == 0) $je_id = COM_makesid();
        $je_date = date("Y-m-d H:i:s",$je_date);
        if ($je_public == on) {
            $je_public = 1;
        } else {
            $je_public = 0;
        }

        if (empty($je_hits)) $je_hits = 0;

        $je_summary = addslashes(htmlspecialchars(strip_tags(COM_checkWords($je_summary))));
        $je_text = addslashes(htmlspecialchars(strip_tags(COM_checkWords($je_text))));

        DB_save($_TABLES["journal_entry"],"je_id,je_jrn_id,je_summary,je_text,je_public,je_hits,je_date,je_mood","$je_id,$je_jrn_id,'$je_summary','$je_text',$je_public,$je_hits,'$je_date','$je_mood'","index.php?mode=user");
        
    } else {
        if (empty($je_summary)) COM_errorLog("Summary is empty");
        if (empty($je_text)) COM_errorLog("Text is empty");
        $retval .= COM_siteHeader();
        COM_errorLog($LANG50[31],2);
        $retval .= journalentryeditor($jrn_id,0);
        $retval .= COM_siteFooter();
    }
    return $retval;
}

function savejournal($jrn_id, $jrn_uid, $jrn_name, $jrn_jt_id, $jrn_public, $jrn_hits, $jrn_date, $jrn_iscurrent) {
	global $_CONF,$LANG12,$LANG50,$LANG01,$_TABLES;

    if (!empty($jrn_name) && !empty($jrn_jt_id)) {	
		$jrn_date = date("Y-m-d H:i:s",$jrn_date);

        if ($jrn_public == on) {
            $jrn_public = 1;
        } else {
            $jrn_public = 0;
        }
        if ($jrn_iscurrent == "on") {
            $jrn_iscurrent = 1;
        } else {
            $jrn_iscurrent = 0;
        }

		if (empty($jrn_hits)) $jrn_hits = 0;

        $jrn_name= addslashes(htmlspecialchars(strip_tags(COM_checkWords($jrn_name))));

		if (strlen($jrn_id)==0) {
            if ($jrn_iscurrent == 1) DB_query("UPDATE {$_TABLES['journal']} SET jrn_iscurrent = 0 WHERE jrn_iscurrent = 1 AND jrn_uid = $jrn_uid");
			DB_save($_TABLES["journal"],"jrn_uid,jrn_name,jrn_jt_id,jrn_public,jrn_hits,jrn_date,jrn_iscurrent","$jrn_uid,'$jrn_name',$jrn_jt_id,$jrn_public,$jrn_hits,'$jrn_date',$jrn_iscurrent","index.php?mode=user");
		} else {
			DB_save($_TABLES["journal"],"jrn_id,jrn_uid,jrn_name,jrn_jt_id,jrn_public,jrn_hits,jrn_date,jrn_iscurrent","$jrn_id,$jrn_uid,'$jrn_name',$jrn_jt_id,$jrn_public,$jrn_hits,'$jrn_date',$jrn_iscurrent","index.php?mode=user");
		}

    } else {
        $retval .= COM_siteHeader();
        COM_errorLog($LANG50[31],2);
        $retval .= journaleditor($br_id);
        $retval .= COM_siteFooter();
    }
    return $retval;
}

function ownsjournal($jrn_id) {
	global $_USER, $_TABLES;
	
	$result = DB_query("SELECT jrn_uid FROM {$_TABLES['journal']} WHERE jrn_id = $jrn_id");
	$A = DB_fetchArray($result);
	if ($_USER["uid"] == $A["jrn_uid"]) {
		return true;
	} else {
		return false;
	}
}

function deletejournalentry($je_id) {
	global $_USER,$_CONF, $_TABLES;

	$result = DB_query("SELECT je_jrn_id FROM {$_TABLES['journal_entry']} WHERE je_id = '$je_id'");
	$A = DB_fetchArray($result);
		
	#make sure the user owns the journal entry before deleting;
	if (ownsjournal($A["je_jrn_id"])) {
		DB_query("DELETE FROM {$_TABLES['journal_entry']} WHERE je_id = '$je_id'");
		echo COM_refresh($_CONF['site_url'] . '/journal/index.php?mode=user&msg=journalentrydeleted');
	} else {
		#some cracker tried deleting something they didn't own...log it
		COM_errorLog("{$_USER["username"]} just tried to delete a journal entry they didn't own",1);
		echo COM_refresh($_CONF['site_url'] . '/journal/index.php?mode=user&msg=illegaldelete');
	}
}

function deletejournal($jrn_id) {
	global $_USER,$_CONF, $_TABLES;

	#make sure the user owns the journal before deleting;
	if (ownsjournal($jrn_id)) {
		#first delete journal entries
		DB_query("DELETE FROM {$_TABLES['journal_entry']} WHERE je_jrn_id = $jrn_id");
		DB_query("DELETE FROM {$_TABLES['journal']} WHERE jrn_id = $jrn_id");
		echo COM_refresh($_CONF['site_url'] . "/journal/index.php?mode=user&msg=journaldeleted");
	} else {
		#some cracker tried deleting something they didn't own...log it
		COM_errorLog("{$_USER["username"]} just tried to delete a journal they didn't own",1);
		echo COM_refresh($_CONF['site_url'] . '/journal/index.php?mode=user&msg=illegaldelete');
	}

	#since this journal is the current journal (has to be in order to delete it)
	#set the current journal to the most recent journal, if any.	
	$result = DB_query("SELECT jrn_id FROM {$_TABLES['journal']} WHERE jrn_uid = {$_USER["uid"]} ORDER BY jrn_date DESC");
	$nrows = DB_numRows($result);
	if ($nrows > 0) {
		$A = DB_fetchArray($result);
		DB_query("UPDATE {$_TABLES['journal']} SET jrn_iscurrent = 1 WHERE jrn_id = {$A["jrn_id"]}");
	}
}

function editjournal($jrn_id, $userwaswarned=0) {
    global $_TABLES;
    
	$result = DB_query("SELECT *,jrn_date as unixdate FROM {$_TABLES['journal']} WHERE jrn_id = $jrn_id");
	$A = DB_fetchArray($result);
	return journaleditor($userwaswarned, $A);
}

function editjournalentry($je_id,$userwaswarned=0) {
    global $_TABLES;
    
	$result = DB_query("SELECT *,jrn_public,je_date as unixdate FROM {$_TABLES['journal_entry']},{$_TABLES['journal']} WHERE jrn_id = je_jrn_id AND je_id = '$je_id'");
	$A = DB_fetchArray($result);
	return journalentryeditor($A["je_jrn_id"],$userwaswarned,$A);	
}
function getjournalprefs() {
	#hardcoded until I get time to implement user preferences
	$PREFS["entriesperpage"] = 30;
	return $PREFS;
}
function showjournalentries($jrn_id,$offset,$mode) {
	global $_CONF,$_TABLES, $LANG_JOURNAL,$_USER,$JOURNAL_PREFS;

	if (empty($jrn_id)) return;

	$result = DB_query("SELECT jrn_name,jrn_uid,jrn_public FROM {$_TABLES['journal']} WHERE jrn_id = $jrn_id");
	$JOURNAL = DB_fetchArray($result);

	$isadmin = false;

	if (SEC_inGroup('Journal Admin') OR $JOURNAL["jrn_uid"] == $_USER["uid"]) {
	    $isadmin = true;
	}

	if (($_USER["uid"] <> $JOURNAL["jrn_uid"]) AND (!($isadmin)) AND ($JOURNAL["jrn_public"] == 0)) {
		#someone is trying to illegally see entries in this journal...log it and bail
		$retval .= COM_startBlock($LANG_JOURNAL[accessviolation]);
		$retval .= $LANG_JOURNAL[accessviolationmsg];
		$retval .= COM_endBlock();
		COM_errorLog("User {$_USER["username"]} tried to illegally access journal {$JOURNAL["jrn_name"]}",1);
		return $retval;
	}

	#handle paging stuff
	$retval .= COM_startBlock($LANG_JOURNAL[entriesinjournal] . " '".stripslashes($JOURNAL["jrn_name"])."'");
	$JOURNAL_PREFS = getjournalprefs();
	$limit = $JOURNAL_PREFS["entriesperpage"];

	# next determine if offset has been passed to script, if not use 0
    if (empty($offset) OR ($offset < 0)) {
        $offset = 0;
    }
	
	# get the data
	if ($isadmin) {
	    $totalrows = DB_count($_TABLES["journal_entry"],"je_jrn_id",$jrn_id);
		$result = DB_query("SELECT * FROM {$_TABLES['journal_entry']} WHERE je_jrn_id = $jrn_id ORDER BY je_date DESC LIMIT $offset,$limit");
	} else {
		$totalrows = DB_count($_TABLES["journal_entry"],"je_jrn_id",$jrn_id,"je_public",1);
		$result = DB_query("SELECT * FROM {$_TABLES['journal_entry']} WHERE je_jrn_id = $jrn_id AND je_public = 1 ORDER BY je_date DESC LIMIT $offset,$limit");
	}

	$nrows = DB_numRows($result);
	$retval .= "<table cellpadding=0 cellspacing=0 width=100%><tr><th width=5%>{$LANG_JOURNAL[mood]}</th><th align=left width=30%>{$LANG_JOURNAL[summary]}</th><th align=left width=15%>{$LANG_JOURNAL[date]}</th><th width=5%>{$LANG_JOURNAL[public]}</th><th width=5%>{$LANG_JOURNAL[hits]}</th></tr>";
	for ($i = 1; $i <= $nrows; $i++) {
		$A = DB_fetchArray($result);
		$curtime = COM_getUserDateTimeFormat($A["je_date"]);
		if (($i % 2) > 0) {
			$retval .= "<tr bgcolor=#DDDDDD>";
		} else {
			$retval .= "<tr>";
		}
		if (empty($A["je_mood"])) {
			$image = $_CONF["site_url"]."/images/speck.gif width=15 height=15";
		} else {
			$image = $_CONF["site_url"]."/journal/images/".$A["je_mood"]."_phpbb.gif alt=".$A["je_mood"];
		}
		$retval .= "<td width=5% align=center><img src=$image></td><td width=30%><a href={$_CONF["site_url"]}/journal/index.php?mode=read&type=entry&je_id={$A["je_id"]}>".stripslashes($A["je_summary"])."</a>";
		if ($isadmin) {
			$retval .= "&nbsp;&nbsp;[<a href={$_CONF["site_url"]}/journal/index.php?mode=edit&type=entry&je_id={$A["je_id"]}>{$LANG_JOURNAL[edit]}</a>]</td>";
		} else {
			$retval .= "</td>";
		}
		$retval .= "<td width=15%>$curtime[0]</td>";
		if ($A["je_public"] == 1) {
			$A["je_public"] = $LANG_JOURNAL[yes];
		} else {
			$A["je_public"] = $LANG_JOURNAL[no];
		}
		$retval .= "<td align=center width=5%>{$A["je_public"]}</td>";
		$retval .= "<td align=center width=5%>{$A["je_hits"]}</td></tr>";
	}
	if ($nrows == 0) {
		$retval .= "<tr><td colspan=4 align=left>{$LANG_JOURNAL["noentriesmsg"]}</td></tr>";
	}

	$retval .= "<tr><td align=center colspan=4>&nbsp;<br>";

	# next we need to do the links to other results
    if ($offset > 0) { # bypass PREV link if offset is 0
        $prevoffset = $offset - 20;
        $retval .= "<a href=\"$PHP_SELF?mode=user&offset=$prevoffset\">$LANG_JOURNAL[previous]</a> &nbsp; \n";
    } else {
        $retval .= $LANG_JOURNAL[previous] . " &nbsp; \n";
	}

	# calculate number of pages needing links
    $pages= intval($totalrows / $limit);

    # $pages now contains int of pages needed unless there is a remainder from division
    if ($numrows%$limit) {
        #has remainder so add one page
        $pages++;
    }

    for ($i=1;$i<=$pages;$i++) { // loop thru
        $newoffset = $limit * ($i-1);
		# only $retval .= link if we aren't on page $i
		if ($i <> ($offset+1)) {
            $retval .= "<a href=\"$PHP_SELF?mode=user&offset=$newoffset\">$i</a> &nbsp; \n";
			$lastpage = false;
		} else {
			$lastpage = true;
            $retval .= "$i &nbsp; \n";
	 	}		
    }

    # check to see if last page
    if (!($lastpage) && $pages > 1) {
        # not last page so give NEXT link
        $newoffset= $offset + $limit;
        $retval .= "<a href=\"$PHP_SELF?offset=$newoffset\">{$LANG_JOURNAL[next]}</a><p>\n";
    } else {
        $retval .= "{$LANG_JOURNAL[next]}<p>\n";
	}
		
	$retval .= "</td></tr></table>";
	
	$retval .= COM_endBlock();
	
	return $retval;
}	
function getprevnextentries($je_id,$jrn_id,$date) {
    global $_TABLES;
    
    $result = DB_query("SELECT je_id FROM {$_TABLES['journal_entry']} WHERE je_date > '" . $date . "' AND je_jrn_id = $jrn_id ORDER BY je_date");
       
	$nrows = DB_numRows($result);
	if ($nrows == 0) {
		$next = false;
	} else {
		$A = DB_fetchArray($result);
		$next = $A["je_id"];
	}

	$result = DB_query("SELECT je_id FROM {$_TABLES['journal_entry']} WHERE je_date < '$date' AND je_jrn_id = $jrn_id ORDER BY je_date DESC");
	$nrows = DB_numRows($result);
	if ($nrows == 0) {
		$prev = false;
	} else {
		$A = DB_fetchArray($result);
		$prev = $A["je_id"];
	} 	
	return array($prev, $next);
}

function printjournalentry($je_id) {
	global $_USER,$LANG01,$LANG_JOURNAL,$_CONF,$_TABLES;

	$result = DB_query("SELECT *,jrn_uid,jrn_name FROM {$_TABLES['journal']},{$_TABLES['journal_entry']} WHERE jrn_id = je_jrn_id AND je_id = '$je_id'");
	$nrows = DB_numRows($result);

	if ($nrows == 0) {
		#oops, user it trying to view something that doesn't exist
		$retval .= COM_startBlock($LANG_JOURNAL[entrydoesnotexist]);
		$retval .= $LANG_JOURNAL[entrydoesnotexistmsg];
		$retval .= COM_endBlock();
		return $retval;
	}

	$A = DB_fetchArray($result);

	$isadmin = false;
	if (($_USER["uid"] == $A["jrn_uid"]) OR (SEC_inGroup('Journal Admin'))) {
		$isadmin = true;
	}

	if (($A["je_public"] == 0) && (!($isadmin))) {
		#somebody just tried to view an entry that they don't have access to 
		#log it and give error message
		$retval .= COM_startBlock($LANG_JOURNAL[accessviolation]);
		$retval .= $LANG_JOURNAL[accessviolationmsg];
		COM_errorLog("User " . $_USER["uid"] . " just tried accessing journal entry $je_id illegally.",1);
		$retval .= COM_endBlock();
		return $retval;
	}

	DB_change($_TABLES["journal_entry"],"je_hits",$A["je_hits"]+1,"je_id","$je_id");
	$A["je_hits"]++;
	$entries = getprevnextentries($je_id, $A["je_jrn_id"], $A["je_date"]);
	$A["prev"] = $entries[0];
	$A["next"] = $entries[1];
	$thedate = COM_getUserDateTimeFormat($A["je_date"]);
	if (!empty($A["je_mood"])) {
		$image = "<img src=" . $_CONF["site_url"] . "/journal/images/" . $A["je_mood"] . "_phpbb.gif alt=" . $A["je_mood"] . ">";
	} else {
		$image = "";
	}
    $retval .= "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n";
    $retval .= "<tr><td class=storytitle>" . stripslashes($A["je_summary"]) . "&nbsp;$image</TD></TR>\n";
    $retval .= "<tr><td height=1 class=storyunderline><IMG SRC={$_CONF["site_url"]}/images/speck.gif width=1 height=1></td></tr>\n";        $retval .= "<tr><td class=storybyline>{$thedate[0]}<br>";
    $retval .= "{$LANG_JOURNAL[journal]}: <a class=storybyline href={$_CONF["site_url"]}/journal/index.php?mode=user&jrn_id={$A["jrn_id"]}>".stripslashes($A["jrn_name"])."</a><br>\n";
    $retval .= "{$LANG_JOURNAL[owner]}: <a class=storybyline href={$_CONF["site_url"]}/users.php?mode=profile&uid={$A["jrn_uid"]}>" . DB_getItem($_TABLES["users"],"username","uid = {$A["jrn_uid"]}") . "</a></td></tr>\n";
    if ($A["je_hits"] > 0) {
        $retval .= "<tr><td class=storybyline>";
        $retval .= "Hits: " . $A["je_hits"] . "</td></tr>\n";
    } else {
        $retval .= "<br>";
    }
    $retval .= "<tr><td>&nbsp;<br>";
    $retval .= nl2br(stripslashes($A["je_text"]));
	$commentCount = DB_count($_TABLES['comments'],'sid',$A['je_id']);
	if ($commentCount == 0) {
		$retval .= "\n</td></tr><tr><td><a href='" .$_CONF[site_url] ."/comment.php?type=journal&cid=" .$A['je_id']. "'>" . $LANG01[60] . "</a>";
	} else {
	    $retval .= "\n</td></tr><tr><td><a href='" .$_CONF[site_url] ."/comment.php?type=journal&cid=" .$A['je_id']. "'>" .$commentCount. ' ' .$LANG01[03] . "</a>";
	}

    $retval .= "\n</td></tr><tr><td>\n<div align=right>\n";

	
	if ($A["prev"]) {
		$retval .= "<a href={$_CONF["site_url"]}/journal/index.php?mode=read&je_id={$A["prev"]}>{$LANG_JOURNAL[previous]}</a>&nbsp;";
	} else {
		$retval .= "{$LANG_JOURNAL[previous]}&nbsp;";
	}

	if ($A["next"]) {
		$retval .= "<a href={$_CONF["site_url"]}/journal/index.php?mode=read&je_id={$A["next"]}>{$LANG_JOURNAL[next]}</a>&nbsp;";
	} else {
		$retval .= "{$LANG_JOURNAL[next]}&nbsp";
	}
	$retval .= "&nbsp;&nbsp;<a href={$_CONF["site_url"]}/journal/index.php?mode=user&jrn_id={$A["jrn_id"]}>" . $LANG_JOURNAL[backto] . stripslashes($A["jrn_name"]) . "</a>&nbsp;";
    // $retval .= "<a href={$_CONF["site_url"]}/journal/index.php?mode=print&je_id=$je_id><img border=0 src={$_CONF["site_url"]}/images/print.gif alt=\"{$LANG01[65]}\"></a>";
    if ($isadmin) {
        $retval .= "<br><a href={$_CONF["site_url"]}/journal/index.php?mode=edit&type=entry&je_id=$je_id>{$LANG_JOURNAL[edit]}</a>";
    }
    $retval .= "</div></td>\n</tr>\n";
    $retval .= "</table><br>\n";
    
    return $retval;
}

function listjournals($uid="") {
	global $_USER, $LANG_JOURNAL, $_CONF, $_TABLES;

	$isadmin = false;

	if (SEC_inGroup('Journal Admin')) {
		$isadmin = true;
	}
	
	if (empty($uid)) {
		if ($isadmin) {
			$result = DB_query("SELECT jrn_uid,username,count(*) AS count,max(jrn_date) FROM {$_TABLES['journal']},{$_TABLES['users']} WHERE uid = jrn_uid GROUP BY jrn_uid ORDER BY username");
			$retval .= COM_startBlock($_CONF['sitename'] . ' ' . $LANG_JOURNAL[alluserjournals]);
		} else {
			$result = DB_query("SELECT jrn_uid,username,count(*) AS count,max(jrn_date) FROM {$_TABLES['journal']},{$_TABLES['users']} WHERE uid = jrn_uid AND jrn_public = 1 GROUP BY jrn_uid ORDER BY username");
			$retval .= COM_startBlock($_CONF['sitename'] . ' ' . $LANG_JOURNAL[publicuserjournals]);
		}

		$nrows = DB_numRows($result);
		if ($isadmin) {
			$retval .= "<table cellpadding=0 cellspacing=0 width=100%><tr><th align=left>{$LANG_JOURNAL[user]}</th><th>{$LANG_JOURNAL[numjournals]}</th></tr>";
		} else {
			$retval .= "<table cellpadding=0 cellspacing=0 width=100%><tr><th align=left>{$LANG_JOURNAL[user]}</th><th>{$LANG_JOURNAL[numpublicjournals]}</th></tr>";
		}
		for ($i = 1;$i <= $nrows;$i++) {
			$A = DB_fetchArray($result);
			$retval .= "<tr><td><a href={$_CONF["site_url"]}/journal/index.php?uid={$A["jrn_uid"]}>{$A["username"]}</a></td><td align=center>{$A["count"]}</td></tr>";		
		}  
		if ($nrows == 0 ) {
			$retval .= $LANG_JOURNAL[nopublicjournalsmsg];
		}
		$retval .= "</table>";
		$retval .= COM_endBlock();
	} else {
		# we have a user id for which to grab journals
		$result = DB_query("SELECT uid FROM {$_TABLES['users']} WHERE uid = $uid");
		$nrows = DB_fetchArray($result);
		if ($nrows == 0) {
			#we just got a bogus user id...bail
			$retval .= COM_startBlock($LANG_JOURNAL[unknownuser]);
			$retval .= $LANG_JOURNAL[unknownusermsg];
			$retval .= COM_endBlock();
			return $retval;
		}
	
		#if an admin, show all journals, public and private
		if (!($isadmin)) {
			#ok, now check to make sure this user does in fact have public journals
			$result = DB_query("SELECT count(*) AS count,username FROM {$_TABLES['journal']},{$_TABLES['users']} WHERE jrn_uid = $uid AND uid = $uid AND jrn_public = 1 GROUP BY jrn_id");
			$A = DB_fetchArray($result);
			if ($A["count"] == 0) {
				#got a valid user id but they don't have any public journals
				$retval .= COM_startBlock($LANG_JOURNAL[nopublicjournals]);
				$retval .= $LANG_JOURNAL[nopublicjournalsmsg];
				$retval .= COM_endBlock();
				return $retval;
			}
		}

		#if we made it here then life is good!
		if ($isadmin) {
			$result = DB_query("SELECT jrn_id,jrn_name,MAX(je_date) AS lastdate,username,count(*) AS count,jt_name FROM {$_TABLES['journal_type']},{$_TABLES['journal']},{$_TABLES['users']} LEFT JOIN {$_TABLES['journal_entry']} ON jrn_id=je_jrn_id WHERE uid = $uid AND jrn_uid = $uid AND jt_id = jrn_jt_id GROUP BY jrn_id ORDER BY lastdate DESC");
			$A = DB_fetchArray($result);
			$retval .= COM_startBlock($LANG_JOURNAL[journalsfor] . ' ' . $A["username"]);
		} else {
			$result = DB_query("SELECT jrn_id,jrn_name,MAX(je_date) AS lastdate,username,count(*) AS count,jt_name FROM {$_TABLES['journal_type']},{$_TABLES['journal']},{$_TABLES['users']} LEFT JOIN {$_TABLES['journal_entry']} ON jrn_id=je_jrn_id WHERE uid = $uid AND jrn_uid = $uid AND jt_id = jrn_jt_id AND jrn_public = 1 AND je_public = 1 GROUP BY jrn_id ORDER BY lastdate DESC");
			$A = DB_fetchArray($result);
			$retval .= COM_startBlock($LANG_JOURNAL[publicjournalsfor] . ' ' . $A["username"]);
		}
		$nrows = DB_numRows($result);
		$retval .= "<table width=100% cellpadding=0 cellspacing=0><th align=left>{$LANG_JOURNAL[journalname]}</th><th>{$LANG_JOURNAL[journaltype]}</th><th align=center>{$LANG_JOURNAL[numentries]}</th><th align=left>{$LANG_JOURNAL[lastentry]}</th></tr>";
		for ($i = 1; $i <= $nrows; $i++) {
			if (empty($A["lastdate"])) {
				$curtime[0] = '';
				$A["count"] = 0;
			} else {
				$curtime = COM_getUserDateTimeFormat($A["lastdate"]);
			}
			if ($i % 2 > 0) {
				$retval .= "<tr bgcolor=#DDDDDD><td><a href={$_CONF["site_url"]}/journal/index.php?mode=user&jrn_id={$A["jrn_id"]}>".stripslashes($A["jrn_name"])."</a></td><td>{$A["jt_name"]}</td><td align=center>{$A["count"]}</td><td>{$curtime[0]}</td></tr>";
			} else {
				$retval .= "<tr><td><a href={$_CONF["site_url"]}/journal/index.php?mode=user&jrn_id={$A["jrn_id"]}>".stripslashes($A["jrn_name"])."</a></td><td>{$A["jt_name"]}</td><td align=center>{$A["count"]}</td><td>{$curtime[0]}</td></tr>";
			}		
			$A = DB_fetchArray($result);
		}
		$retval .= "</table>";
		$retval .= COM_endBlock();
	}
	return $retval;
}

/**
* Removes the datastructures for this plugin from the Geeklog database
*
* This may get called by the install routine to undue anything done to this
* point.  To do that, $steps will have a list of steps to undo
*
* @steps   Array    Holds all the steps that have been completed by the install
*
*/  

function plugin_uninstall_journal($steps = '') {
    global $_TABLES, $LANG_JOURNAL;
    // Uninstalls the Journal plugin
    // Check and see if plugin is still enabled - if so display warning and exit
	if ($steps == 'removeplugin') {
         $pi_name='journal';
		 if (DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
		    COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
			$display .= COM_startBlock($LANG_JOURNAL['warning']);
			$display .= $LANG_JOURNAL['enabled'];
			$display .= COM_endBlock();
			echo $display;
			exit;
		}  
	}
		
	
    if (empty($steps) OR $steps['createtablejournal'] == 1) {
        // Remove the journal table 
        COM_errorLog('Dropping journal table',1);
        DB_query("DROP TABLE {$_TABLES['journal']}");
        COM_errorLog('...success',1);
    }
    
    if (empty($steps) OR $steps['createtablejournalentry'] == 1) {
        // Remove the journal table 
        COM_errorLog('Dropping journal_entry table',1);
        DB_query("DROP TABLE {$_TABLES['journal_entry']}");
        COM_errorLog('...success',1);
    }
    
    if (empty($steps) OR $steps['createtablejournaltype'] == 1) {
        // Remove the journal table 
        COM_errorLog('Dropping journal_type table',1);
        DB_query("DROP TABLE {$_TABLES['journal_type']}");
        COM_errorLog('...success',1);
    }

    // Remove security for this plugin

    // Remove the Journal admin group
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'jrn_group_id'");

    if (empty($steps) OR $steps['insertgroup'] == 1) {
        COM_errorLog('Attempting to remove the Journal Admin Group', 1);
        DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id");
        COM_errorLog('...success',1);
    }

    // Remove related features
    $edit_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'journal.edit'");
    $delete_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'journal.delete'");

    if (empty($steps) OR $steps['addededittogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to journal.edit from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $edit_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addeddeletetogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to journal.delete from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $delete_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addedrootuserstogroup'] == 1) {
        // Remove root users from the group
        COM_errorLog('Attempting to remove root users from admin of Journal');
        DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeatureedit'] == 1) {
        COM_errorLog('Attempting to remove the journal.edit feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $edit_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeaturedelete'] == 1) {
        COM_errorLog('Attempting to remove the journal.delete feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $delete_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['savedgroupid']) {
        COM_errorLog('Attempting to remove the group id from the vars table',1);
        DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'jrn_group_id'");
        COM_errorLog('success',1);
    }

    // Unregister the plugin with Geeklog
    if (empty($steps)) {
        COM_errorLog('Attempting to unregister the plugin from Geeklog',1);
        DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'journal'");
        DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'journal'");
        COM_errorLog('...success',1);

        COM_errorLog('leaving plugin_uninstall_journal',1);
        return true;
    } else {
        return false;
    }
}


?>
