<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Journal Plugin for Geeklog - The Ultimate Weblog                          |
// +---------------------------------------------------------------------------+
// | index.php                                                                 |
// |                                                                           |
// | This is the home page for the Journal plug-in                             |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tony Bibbs       - tony@tonybibbs.com                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: index.php,v 1.1.1.1 2003/06/10 20:33:24 dirk Exp $

include("../lib-common.php");

if (DB_getItem ($_TABLES['plugins'], 'pi_enabled', "pi_name = 'journal'") == 0) {
    $display .= COM_siteHeader();
    $display .= 'Sorry, the journal plugin is not enabled';
    $display .= COM_siteFooter();
    echo $display;
    exit;
}

if (($mode <> "changejournal") AND ($verified <> 1) AND ($mode <> "save")) {
    $display .= COM_siteHeader();
}

// if not anonymous, get current journal 
if ($_USER['uid'] > 1) {
    $cur_journal = DB_getItem ($_TABLES['journal'], 'jrn_id',
            "jrn_uid = {$_USER['uid']} AND jrn_iscurrent = 1");
}

switch ($mode) {
    case $LANG_JOURNAL['cancel']:
        // note: I purpose don't have anything in this so that when a use
        //       clicks cancel on a form they route to the user page
    case 'user':
        if (!empty($jrn_id)) {
            // viewing someone elses public journal
            $display .= shownavigation($mode, $jrn_id);
            $display .= showjournalentries($jrn_id,$offset,$mode);
        } else {
            // viewing privat journal
            $display .= shownavigation($mode,$cur_journal);
            $display .= showjournalentries($cur_journal,$offset,$mode);
        }
        break;
    case 'edit':
        if ($type == 'entry') {
            $display .= shownavigation($mode,$cur_journal);
            $display .= editjournalentry($je_id);
        } else if ($type == 'journal') {
            $display .= shownavigation($mode,$cur_journal);
            $display .= editjournal($jrn_id);
        }
        break;
    case 'read':
        $jrn_id = DB_getItem ($_TABLES['journal_entry'], 'je_jrn_id',
                              "je_id = '$je_id'");
        $display .= shownavigation($mode,$jrn_id);
        $display .= printjournalentry($je_id);
        break;
    case 'changejournal':
        changejournal($jrn_id);
        break;
    case 'newjournal':
        $display .= shownavigation('user');
        $display .= journaleditor(0);
        break;
    case 'newentry':
        $display .= shownavigation('user',$cur_journal);
        $display .= journalentryeditor($cur_journal,0);
        break;
    case $LANG_JOURNAL['delete']:
        if ($type == 'journal') {
            if ($verified == 0) {
                $display .= COM_startBlock($LANG_JOURNAL['deletejournalqmark']);
                $display .= $LANG_JOURNAL['deletejournalwarning'];
                $display .= COM_endBlock();
                // the 1 lets us know the user was warned
                $display .= editjournal($jrn_id, 1);
            } else {
                deletejournal($jrn_id);
            }
        } else if ($type == 'entry') {
            if ($verified == 0) {
                $display .= COM_startBlock($LANG_JOURNAL['deleteentryqmark']);
                $display .= $LANG_JOURNAL['deleteentrywarning'];
                $display .= COM_endBlock();
                $display .= editjournalentry($je_id, 1);
            } else {
                deletejournalentry($je_id);
            }
        }
        break;
    case $LANG_JOURNAL['save']:
        if ($type == 'journal') {
            // $display .= shownavigation('user');
            savejournal($jrn_id, $jrn_uid, $jrn_name, $jrn_jt_id, $jrn_public,
                        $jrn_hits, $unixdate, $jrn_iscurrent);
        } else if ($type == 'entry') {
            // $display .= shownavigation('user');
            savejournalentry($je_id, $je_jrn_id, $je_summary, $je_text,
                             $je_public, $unixdate, $je_hits, $je_mood);
        }
        break;	
    default:
        $display .= shownavigation($mode,$cur_journal);
        $display .= listjournals($uid);
        break;
}
if (($mode <> 'changejournal') AND ($verified <> 1) AND ($mode <> 'save')) {
    $display .= COM_siteFooter();
}

echo $display;

?>
